<?php
/* ͕h~̂߂̓{ꕶłB
   ̃\[Xt@C Shift_JIS ŕۑĂ܂B
   Above is a Japanese strings to avoid charset mis-understanding.
   This source file is saved with Shift_JIS. */

/* ==================================================
 *   Ktai_Services class
   ================================================== */

class Ktai_Services {
	private $type;

/* ==================================================
 * @param	none
 * @return	object
 */
public function factory() {
	$type = NULL;
	$ua = $_SERVER['HTTP_USER_AGENT'];
	if (preg_match('#^DoCoMo/#', $ua)) {
		$type = new Ktai_Service_imode;
	} elseif (preg_match('#^(J-PHONE/|Vodafone/|MOT-[CV]|SoftBank/)#', $ua)) {
		$type = new Ktai_Service_Softbank;
	} elseif (preg_match('#(DDIPOCKET|WILLCOM|Windows CE; SHARP/WS\\d+SH);#', $ua)) {
		$type = new Ktai_Service_imode; // WILLCOM uses the same charset as DoCoMo
	} elseif (preg_match('#^(KDDI-|UP\.Browser)#',$ua)) {
		$type = new Ktai_Service_EZweb;
	} elseif (preg_match('#Nokia\\d+\\s*/#', $ua)) {
		$type = new Ktai_Service_Other;
	} elseif (defined('KS_DEBUG') && preg_match('#Camino#', $ua)) {
		$type = new Ktai_Service_Other;
	}
	return $type;
}

// ===== End of class ====================
}

/* ==================================================
 *   Ktai_Service_Other class
   ================================================== */

class Ktai_Service_Other extends Ktai_Services {

/* ==================================================
 * @param	string $buffer
 * @return	string $buffer
 */
public function convert_char($buffer) {
	$buffer = preg_replace('#<img localsrc="(.*?)"( alt="(.*?)")? ?/?>#', '\3', $buffer);
	return $buffer;
}

// ===== End of class ====================
}

/* ==================================================
 *   Ktai_Service_EZweb class
   ================================================== */

class Ktai_Service_EZweb extends Ktai_Services {

/* ==================================================
 * @param	string $buffer
 * @return	string $buffer
 */
public function convert_char($buffer) {
	$buffer = preg_replace('#<img localsrc="(.*?)"( alt=".*?")? ?/?>#', '<img localsrc="\\1">', $buffer);
	return $buffer;
}

// ===== End of class ====================
}

/* ==================================================
 *   Ktai_Service_imode class
 *   Reference: http://www.nttdocomo.co.jp/service/imode/make/content/pictograph/basic/
 *              http://www.au.kddi.com/ezfactory/tec/spec/3.html
   ================================================== */

class Ktai_Service_imode extends Ktai_Services {

/* ==================================================
 * @param	string $buffer
 * @return	string $buffer
 */
public function convert_char($buffer) {
	$chars = array (
		'5'   => '',       // left
		'6'   => '',       // right
		'16'  => '&#63651;', // thunder
		'29'  => '',       // up
		'30'  => '',       // down
		'44'  => '&#63647;', // sun
		'46'  => '&#63838;', // clock
		'50'  => '&#63829;', // face (female)
		'51'  => '&#63889;', // heart
		'56'  => '&#63722;', // note
		'68'  => '&#63893;', // smile
		'77'  => '&#63904;', // lamp
		'80'  => '&#63829;', // face (male)
		'94'  => '&#63714;', // camera
		'95'  => '&#63649;', // rain
		'107' => '&#63648;', // cloud
		'108' => '&#63863;', // mail envelope
		'109' => '&#63866;', // money
		'119' => '&#63873;', // magnifier (search)
		'120' => '&#63869;', // key
		'149' => '&#63826;', // pen
		'168' => '&#63683;', // air plane
		'169' => '&#63682;', // boat (ship)
		'172' => '&#63676;', // train
		'180' => '&#63879;', // one
		'181' => '&#63880;', // two
		'182' => '&#63881;', // three
		'183' => '&#63882;', // four
		'184' => '&#63883;', // five
		'185' => '&#63884;', // six
		'186' => '&#63885;', // seven
		'187' => '&#63886;', // eight
		'188' => '&#63887;', // nine
		'190' => '&#63652;', // storm
		'191' => '&#63650;', // snowball
		'265' => '&#63891;', // heart break
		'299' => '&#63867;', // free
		'303' => '[up!]',    // updated
		'305' => '&#63653;', // fog
		'325' => '&#63888;', // zero
		'334' => '&#63874;', // new
		'\\d+' => '',      // (catch all)
	);
	$pat = preg_replace('/^(.*)$/', '#<img localsrc="\\1"( alt=".*?")? ?/?>#', array_keys($chars));
	$buffer = preg_replace($pat, $chars, $buffer);
	return $buffer;
}

// ===== End of class ====================
}

/* ==================================================
 *   Ktai_Service_Softbank class
 *   Reference: http://developers.softbankmobile.co.jp/dp/tool_dl/web/picword_top.php
 *              http://www.au.kddi.com/ezfactory/tec/spec/3.html
   ================================================== */

class Ktai_Service_Softbank extends Ktai_Services {

/* ==================================================
 * @param	string $buffer
 * @return	string $buffer
 */
public function convert_char($buffer) {
	$chars = array (
		'5'   => '$F[', // left
		'6'   => '$FZ', // right
		'16'  => '$E]', // thunder
		'29'  => '$FR', // up
		'30'  => '$FS', // down
		'44'  => '$Gj', // sun
		'46'  => '$GF', // clock
		'50'  => '$G"', // face (female)
		'51'  => '$GB', // heart
		'56'  => '$O!', // note
		'68'  => '$Gv', // smile
		'80'  => '$G!', // face (male)
		'77'  => '$E/', // lamp
		'94'  => '$G(', // camera
		'95'  => '$Gk', // rain
		'107' => '$Gi', // cloud
		'108' => '$E#', // mail envelope
		'108' => '$EO', // money
		'119' => '$E4', // magnifier (search)
		'120' => '$G_', // key
		'149' => '$O!', // pen
		'168' => '$G=', // air plane
		'169' => '$F"', // boat (ship)
		'172' => '$G>', // train
		'180' => '$F<', // one
		'181' => '$F=', // two
		'182' => '$F>', // three
		'183' => '$F?', // four
		'184' => '$F@', // five
		'185' => '$FA', // six
		'186' => '$FB', // seven
		'187' => '$FC', // eight
		'188' => '$FD', // nine
		'190' => '$Pc', // storm
		'191' => '$Gh', // snowball
		'265' => '$GC', // heart break
		'299' => '$F6', // free
		'303' => '$F3', // updated
		'305' => '[]',  // fog
		'325' => '$FE', // zero
		'334' => '$F2', // new
		'\\d+' => '',   // (catch all)
	);
	$pat = preg_replace('/^(.*)$/', '#<img localsrc="\\1"( alt=".*?")? ?/?>#', array_keys($chars));
	$buffer = preg_replace($pat, $chars, $buffer);
	return $buffer;
}

// ===== End of class ====================
}

?>
